%define name            jalopy
%define version         1.0
%define release         0.b10.1jpp

%define javadir         %{_datadir}/java
%define javadocdir      %{_datadir}/javadoc
%define section         free

# -----------------------------------------------------------------------------

Summary:        Java Source Code Formatter Beautifier Pretty Printer
Name:           %{name}
Version:        %{version}
Release:        %{release}
Group:          Software Development/Quality Assurance
License:        BSD
URL:            http://jalopy.sourceforge.net/
BuildArch:      noarch
Source0:        http://download.sourceforge.net/jalopy/jalopy-1.0b10.src.tar.gz
Source1:        jalopy.jalopy.script
Source2:        jalopy.jalopy-preferences.script
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root
Vendor:         JPackage Project
Distribution:   JPackage
BuildRequires:  ant >= 1.4
BuildRequires:  oro
BuildRequires:  log4j
BuildRequires:  jdom
BuildRequires:  junit
BuildRequires:  gnu.getopt
BuildRequires:  saxon
BuildRequires:  docbook-xsl-java-saxon
# This one's named the same on many distros and is located in same place...
BuildRequires:  docbook-style-xsl
Requires:       log4j
Requires:       jdom
Requires:       oro

%description
Jalopy is a source code formatter for the Sun Java programming language. It
layouts any valid Java source code according to some widely configurable rules;
to meet a certain coding style without putting a formatting burden on
individual developers.

With Jalopy you will be able to transform any foreign coding style to your own
preferences, without any browbeating or bloodletting.

# -----------------------------------------------------------------------------

%package console
Group:          Software Development/Quality Assurance
Summary:        Console plugin for %{name}
Requires:       %{name} = %{version}-%{release}
Requires:       log4j
Requires:       gnu.getopt
Requires:       jdom

%description console
Console plugin for %{name}.

# -----------------------------------------------------------------------------

%package ant
Group:          Software Development/Quality Assurance
Summary:        Ant plugin for %{name}
Requires:       %{name} = %{version}-%{release}
Requires:       ant >= 1.4

%description ant
Ant plugin for %{name}.

# -----------------------------------------------------------------------------

%package manual
Group:          Software Development/Quality Assurance
Summary:        Manual for %{name}

%description manual
Documentation for %{name}.

# -----------------------------------------------------------------------------

%package javadoc
Group:          Development/Documentation
Summary:        Javadoc for %{name}

%description javadoc
Javadoc for %{name}.

# -----------------------------------------------------------------------------

%prep
%setup -q -c
# Jalopy has a custom antlr, need to use it.
rm -f `find -type f -name "*.jar" -a ! -name "antlr-*"`
# Fix path to DocBook XSL's.
perl -pi -e 's|^DIR\.DOCBOOK\.XSL\s*=.*|DIR.DOCBOOK.XSL = %{_datadir}/sgml/docbook/xsl-stylesheets|' build/build.properties

# -----------------------------------------------------------------------------

%build
export CLASSPATH=\
%{javadir}/ant.jar:\
%{javadir}/oro.jar:\
%{javadir}/log4j.jar:\
%{javadir}/jdom.jar:\
%{javadir}/junit.jar:\
%{javadir}/gnu.getopt.jar:\
%{javadir}/saxon.jar:\
%{javadir}/docbook-xsl-saxon.jar
cd build
ant \
  -Dbuild.sysclasspath=first \
  build-jar-main \
  build-jar-console \
  build-jar-ant \
  build-docu

# -----------------------------------------------------------------------------

%install
rm -rf $RPM_BUILD_ROOT

# jar
mkdir -p $RPM_BUILD_ROOT%{javadir}
cp tmp~/build/jars/jalopy-1*.jar \
  $RPM_BUILD_ROOT%{javadir}/%{name}-%{version}.jar
cp tmp~/build/jars/jalopy-ant-*.jar \
  $RPM_BUILD_ROOT%{javadir}/%{name}-ant-%{version}.jar
cp tmp~/build/jars/jalopy-console-*.jar \
  $RPM_BUILD_ROOT%{javadir}/%{name}-console-%{version}.jar
(cd $RPM_BUILD_ROOT%{javadir} && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

# scripts
mkdir -p $RPM_BUILD_ROOT%{_bindir}
cp %{SOURCE1} $RPM_BUILD_ROOT%{_bindir}/%{name}
cp %{SOURCE2} $RPM_BUILD_ROOT%{_bindir}/%{name}-preferences

# javadoc
mkdir -p $RPM_BUILD_ROOT%{javadocdir}/%{name}-%{version}
cp -pr tmp~/docs/api/* $RPM_BUILD_ROOT%{javadocdir}/%{name}-%{version}/

# combine docs with manual, fix javadoc link
mv tmp~/docs/site/* tmp~/docs/manual/
ln -s %{javadocdir}/%{name}-%{version} tmp~/docs/manual/api

# -----------------------------------------------------------------------------

%clean
rm -rf $RPM_BUILD_ROOT

# -----------------------------------------------------------------------------

%files
%defattr(0644,root,root,0755)
%attr(0755,root,root) %{_bindir}/%{name}-preferences
%{javadir}/%{name}.jar
%{javadir}/%{name}-%{version}.jar

%files console
%defattr(0644,root,root,0755)
%attr(0755,root,root) %{_bindir}/%{name}
%{javadir}/%{name}-console*

%files ant
%defattr(0644,root,root,0755)
%{javadir}/%{name}-ant*

%files manual
%defattr(0644,root,root,0755)
%doc tmp~/docs/manual/*

%files javadoc
%defattr(0644,root,root,0755)
%{javadocdir}/%{name}-%{version}

# -----------------------------------------------------------------------------

%changelog
* Fri Nov 15 2002 Ville Skytt <ville.skytta at iki.fi> - 1.0-0.b9.1jpp
- Update to 1.0b10.

* Wed Nov 13 2002 Ville Skytt <ville.skytta at iki.fi> - 1.0-0.b9.1jpp
- Update to 1.0b9.
- Fix Group tags of manual and javadoc.
- Update preferences shell script main class.

* Sat Oct 12 2002 Ville Skytt <ville.skytta at iki.fi> - 1.0-0.b8.1jpp
- First JPackage release.
